var communicationBridge = function() {
    var callbacks = {};

    function getNewId() {
        var cbId = Math.round(Math.random() * 999999999);
        while (cbId in callbacks) {
            cbId = Math.round(Math.random() * 999999999);
        }
        return cbId;
    }

    window.callbackFromNative = function(id, params) {
        console.log('response for', id);
        var cbItem = callbacks[id];
        if (cbItem && typeof(cbItem.callback) === 'function') {
            cbItem.callback.call(cbItem.context, params);
        }

        delete callbacks[id];
    };

    var nativeReq = function(param) {

        var callBackId = "" + getNewId();

        callbacks[callBackId] = {
            context: param.ctx,
            callback: param.success
        };

        if (popupBridge) {
            if (param.data === "" || param.data === undefined || param.data === null) popupBridge[param.fn](callBackId);
            else popupBridge[param.fn](callBackId, param.data);
        }
        console.log(param.fn, callBackId);
    };

    return {
        nativeReq: nativeReq
    };
}();

var productPopUp = {
    data: '',
    imageSelection: function() {


        var imgContainer = document.getElementsByClassName('imageContainer')[0];
        var images = imgContainer.getElementsByTagName('img');
        var cta1 = document.getElementsByClassName('cta1')[0];
        var that = this;

        for (var i = 0; i < images.length; i++) {
            images[i].addEventListener('click', function(e) {
                if (window.getComputedStyle(this).opacity == "0")
                    return;
                
                var active = imgContainer.querySelectorAll('img.active');
                
                for (var k = 0; k < active.length; k++) {
                    active[k].classList.remove('active');
                    if (active[k] && active[k].parentNode) {
                        active[k].parentNode.classList.remove('active');
                    }
                }

                this.classList.add('active');
                
                this.parentNode.classList.add('active');

                var data = this.getAttribute('data-url');
                cta1.setAttribute('data-url', data);
                that.data = JSON.parse(data);
                that.activeImage = this.src;


                document.getElementById('centerSticker').src = this.src;


            });
        }
    },

    bindCSS: function() {

        var btnBgColor = document.getElementById('btnBgColor').value;
        var btnTextColor = document.getElementById('btnTextColor').value;
        var stickerActiveColor = document.getElementById('stickerActiveColor').value;

        var style = document.createElement("style");
        style.appendChild(document.createTextNode(""));
        document.head.appendChild(style);
        style.sheet.insertRule(".imageContainer .active{ background :" + stickerActiveColor + " !important;}", 0);
        //style.sheet.insertRule(".popUpBtn { background: " + btnBgColor + ";  color     : " + btnTextColor + "; }", 0);

    },

    confirm: function() {
        var confirm = document.getElementsByClassName('cardConfirm')[0];
        var popupCard = document.getElementById('popUpCard');
        var image = confirm.getElementsByClassName('cardConfirmHero')[0];
        document.getElementById('subtitle2').innerHTML = document.getElementById('subtitle2').innerHTML;
        image.src = this.activeImage;
        popupCard.classList.add('hide');
        confirm.classList.remove('hide');
        document.getElementsByClassName('cardDblConfirm')[0].classList.add('hide');
    },
    callBridge: function(obj) {
        if (obj.parentNode.parentNode == document.getElementsByClassName('ninthSection')[0] &&
            window.getComputedStyle(document.getElementsByClassName('ninthSection')[0]).opacity == "0")
            return;

        if (obj.getAttribute("data-double-confirm") == "true") {
            var confirm = document.getElementsByClassName('cardDblConfirm')[0];
            var popupCard = document.getElementById('popUpCard');
            var image = confirm.getElementsByClassName('cardConfirmHero')[0];
            image.src = this.activeImage;
            popupCard.classList.add('hide');
            confirm.classList.remove('hide');
            return;

        }

        if (obj.getAttribute("navigateBack") == "true") {
            var confirm = document.getElementsByClassName('cardDblConfirm')[0];
            var popupCard = document.getElementById('popUpCard');
            confirm.classList.add('hide');
            popupCard.classList.remove('hide');
            return;

        }
        var action = obj.getAttribute("data-action");
        var url = obj.getAttribute("data-url");
        if (!obj.classList.contains('optionTxt'))
            var serviceUrl = JSON.parse(JSON.stringify(eval("(" + url + ")"))).url;
        var htm = obj.innerHTML;
        var toast = obj.getAttribute('data-toast');
        var that = this;
        var analyticEvents = {};
        analyticEvents["ek"] = "ppopup";
        analyticEvents["pid"] = document.getElementById("popUpCard").getAttribute("data-pid");


        if (action == 'tip') {
            document.getElementById("follow").classList.remove("hide");
            document.getElementById("followMe").classList.remove("hide");
            document.getElementById("followMe").style.display = "block";
            document.getElementById("div5").style.display = "block";
            document.getElementById("arrow").classList.remove("hide");
            document.getElementById("actionPopUp").children[0].innerHTML = '';

        } else if (action == 'callserver') {
            var data = {
                url: serviceUrl,
                params: {
                    catId: this.data.catId,
                    sId: this.data.stkId
                }
            };

            data = JSON.stringify(data);
            communicationBridge.nativeReq({
                fn: 'doPostRequest',
                ctx: this,
                data: data,
                success: function(response) {
                    response = JSON.parse(decodeURIComponent(response));

                    if (response.status === 'success' && response.status_code === 200) {
                        that.confirm();
                    } else {
                        popupBridge.showToast("Please check your internet connection.");
                    }
                },
                error: function(xhr) {
                    popupBridge.showToast("Please check your internet connection.");
                }
            });

        } else if (action == 'closeapp') {
            popupBridge.onSubmit("{'screen':'cancel'}", null);
        } else if (obj.classList.contains('optionTxt')) {

            var question = document.getElementsByClassName('question')[0].innerHTML;
            analyticEvents["od1"] = "crossquestion_submit" + '@' + question;
            analyticEvents["od2"] = htm;
            platform.logAnalytics("true", "click", analyticEvents);
            popupBridge.onSubmit("{'screen':'cancel'}", null);


        } else {

            var visibleCard = document.querySelectorAll('.card:not(.hide)')[0];
            var optionOverlay = document.getElementsByClassName('optionOverlay');
            var optionContainer = document.getElementsByClassName('optionContainer');


            if (optionOverlay.length > 0 && obj.id == "closeSomething" && (!visibleCard.classList.contains('cardConfirm'))) {

                optionOverlay[0].classList.remove('hide');
                optionContainer[0].classList.remove('hide');
                analyticEvents["od1"] = "crossquestion_load";
                platform.logAnalytics("true", "click", analyticEvents);
                return;

            } else {

                if (typeof url != "undefined" && url != null && url != "")
                    popupBridge.onSubmit(action, url);
                else
                    popupBridge.onSubmit(action, null);

            }
        }

        if (obj.id == "closeSomething")
            analyticEvents["od1"] = "crossIcon";
        else
            analyticEvents["od1"] = htm;



        analyticEvents["od2"] = document.getElementById("popUpCard").getAttribute("data-popupId");
        platform.logAnalytics("true", "click", analyticEvents);
    },
    selectSticker: function() {
        var imgContainer = document.getElementsByClassName('imageContainer')[0];
        var active = imgContainer.getElementsByClassName('active')[0];
        var cta1 = document.getElementsByClassName('cta1')[0];
        var data = active.getAttribute('data-url');

        cta1.setAttribute('data-url', data);
        this.data = JSON.parse(data);
        this.activeImage = active.src;
    },



    init: function() {

        this.selectSticker();
        this.imageSelection();
        this.bindCSS();

    }
}

var fireappload = events.subscribe('/fire/page/load/', function() {
    var card = document.getElementById("popUpCard");
    var height = card.getBoundingClientRect();
    var bodyEle = document.body.getBoundingClientRect();

    console.log(height);
    if (card.getAttribute('data-fullscreen') != 'true') popupBridge.onLoadFinished(height.bottom + "");

    card.classList.add('animateCls');

});

window.onload = function() {
    console.log("in set height");
    events.publish('/platform/app.init/');

};

productPopUp.init();